summaryrefslogtreecommitdiff
path: root/bin/encode+stream
diff options
context:
space:
mode:
authorJonas Smedegaard <dr@jones.dk>2017-04-12 09:21:49 +0200
committerJonas Smedegaard <dr@jones.dk>2017-04-12 09:51:00 +0200
commita00babb88ffab4edcd459cf21b99dbe716f724a1 (patch)
tree349932a83c037258b40d346439f959cb84795fe2 /bin/encode+stream
parent53cce70d95bf093e3ae0d4843ad3a9089945a9cd (diff)
Add decode+edit encode+stream.
Diffstat (limited to 'bin/encode+stream')
-rwxr-xr-xbin/encode+stream29
1 files changed, 29 insertions, 0 deletions
diff --git a/bin/encode+stream b/bin/encode+stream
new file mode 100755
index 0000000..e23b8a1
--- /dev/null
+++ b/bin/encode+stream
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+set -e
+
+HOST=${1:-morla}
+if [ "$HOST" = "$(hostname --short)" ]; then
+ IP=127.0.0.1
+else
+ IP=$(host "$HOST" | grep -Po 'address \K\S+')
+fi
+
+PORT=${2:-5004}
+
+BITRATE=500000
+
+TMPMOVIE=../tmp/omni/show0/earth.yuv
+
+# based on http://www.webmproject.org/docs/encoder-parameters/
+# example "Real-time CBR Encoding and Streaming"
+# + Drop frames, aggressively treat as static, and use fastest cpu
+ffmpeg -threads auto -re \
+ -stream_loop -1 -i "$TMPMOVIE" \
+ -codec:v vp8 -quality realtime -deadline realtime -cpu-used 15 \
+ -b:v "$BITRATE" -minrate "$BITRATE" -maxrate "$BITRATE" \
+ -undershoot-pct 95 -bufsize $((6000*BITRATE/1000)) -rc_init_occupancy $((4000*BITRATE/1000)) \
+ -max-intra-rate 0 \
+ -qmin 4 -qmax 56 \
+ -static-thresh 500 -skip_threshold 50 \
+ -an -f rtp "rtp://$IP:$PORT?pkt_size=1200"